<?php


/*
  ----------------------------------------------------------------------
  GLPI - Gestionnaire Libre de Parc Informatique
  Copyright (C) 2003-2008 by the INDEPNET Development Team.
  
  http://indepnet.net/   http://glpi-project.org/
  ----------------------------------------------------------------------
  
  LICENSE
  
  This file is part of GLPI.
  
  GLPI is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  GLPI is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with GLPI; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  ------------------------------------------------------------------------
 */

// ----------------------------------------------------------------------
// Original Author of file: Walid Nouh
// Purpose of file:
// ----------------------------------------------------------------------

if (!defined('GLPI_ROOT')) {
	die("Sorry. You can't access directly to this file");
}

function plugin_data_injection_Install() {
	global $DB;

	$query = "CREATE TABLE IF NOT EXISTS `glpi_plugin_data_injection_models` (
							  `ID` int(11) NOT NULL auto_increment,
							  `name` varchar(255) NOT NULL,
							  `comments` text,
							  `date_mod` datetime NOT NULL default '0000-00-00 00:00:00',
							  `type` int(11) NOT NULL default '1',
							  `device_type` int(11) NOT NULL default '1',
							  `FK_entities` int(11) NOT NULL default '-1',
							  `behavior_add` int(1) NOT NULL default '1',
							  `behavior_update` int(1) NOT NULL default '0',
							  `can_add_dropdown` int(1) NOT NULL default '0',
							  `can_overwrite_if_not_empty` int(1) NOT NULL default '1',
							  `private` int(1) NOT NULL default '1',
							  `recursive` int(1) NOT NULL default '0',
							  `perform_network_connection` int(1) NOT NULL default '0',
							  `FK_users` int(11) NOT NULL,
							  `date_format` varchar(11) NOT NULL default 'yyyy-mm-dd',
							  `float_format` INT( 1 ) NOT NULL DEFAULT '0',
							  `port_unicity` INT( 1 ) NOT NULL DEFAULT '0',
							  PRIMARY KEY  (`ID`) 
							) ENGINE=MyISAM CHARSET=utf8 COLLATE=utf8_unicode_ci;";

	$DB->query($query) or die($DB->error());

	$query = "CREATE TABLE IF NOT EXISTS `glpi_plugin_data_injection_models_csv` (
							  `ID` int(11) NOT NULL auto_increment,
							  `model_id` int(11) NOT NULL,
							  `device_type` int(11) NOT NULL default '1',
							  `delimiter` varchar(1) NOT NULL default ';',
							  `header_present` int(1) NOT NULL default '1',
							  PRIMARY KEY  (`ID`)
							) ENGINE=MyISAM CHARSET=utf8 COLLATE=utf8_unicode_ci;";

	$DB->query($query) or die($DB->error());

	$query = "CREATE TABLE IF NOT EXISTS `glpi_plugin_data_injection_mappings` (
								`ID` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
								`model_id` INT( 11 ) NOT NULL ,
								`type` INT( 11 ) NOT NULL DEFAULT '1',
								`rank` INT( 11 ) NOT NULL ,
								`name` VARCHAR( 255 ) NOT NULL ,
								`value` VARCHAR( 255 ) NOT NULL ,
								`mandatory` INT( 1 ) NOT NULL DEFAULT '0'		
								) ENGINE = MYISAM CHARSET=utf8 COLLATE=utf8_unicode_ci ;";
	$DB->query($query) or die($DB->error());

	$query = "CREATE TABLE IF NOT EXISTS `glpi_plugin_data_injection_infos` (
								`ID` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
								`model_id` INT( 11 ) NOT NULL ,
								`type` int(11) NOT NULL default '9',
								`value` VARCHAR( 255 ) NOT NULL ,
								`mandatory` INT( 1 ) NOT NULL DEFAULT '0'		
								) ENGINE = MYISAM CHARSET=utf8 COLLATE=utf8_unicode_ci ;";
	$DB->query($query) or die($DB->error());

	$query = "CREATE TABLE IF NOT EXISTS `glpi_plugin_data_injection_filetype` (
							  `ID` int(11) NOT NULL auto_increment,
							  `name` varchar(255) NOT NULL,
							  `value` int(11) NOT NULL,
							  `backend_class_name` varchar(255) NOT NULL,
							  `model_class_name` varchar(255) NOT NULL,
							  PRIMARY KEY  (`ID`)
							) ENGINE=MyISAM AUTO_INCREMENT=2  CHARSET=utf8 COLLATE=utf8_unicode_ci;
							";
	$DB->query($query) or die($DB->error());

	$query = "REPLACE INTO `glpi_plugin_data_injection_filetype` (`ID`, `name`, `value`, `backend_class_name`, `model_class_name`) VALUES 
						(1, 'CSV', 1, 'BackendCSV', 'DataInjectionModelCSV');";
	$DB->query($query) or die($DB->error());

	$query = "CREATE TABLE IF NOT EXISTS `glpi_plugin_data_injection_profiles` (
							  `ID` int(11) NOT NULL auto_increment,
							  `name` varchar(255) default NULL,
							  `is_default` int(6) NOT NULL default '0',
							  `model` char(1) default NULL,
							  PRIMARY KEY  (`ID`)
							) ENGINE=MyISAM CHARSET=utf8 COLLATE=utf8_unicode_ci;";
	$DB->query($query) or die($DB->error());

	if (!is_dir(PLUGIN_DATA_INJECTION_UPLOAD_DIR)) {
		@ mkdir(PLUGIN_DATA_INJECTION_UPLOAD_DIR) or die("Can't create folder " . PLUGIN_DATA_INJECTION_UPLOAD_DIR);
	}
}

function plugin_data_injection_uninstall() {
	global $DB;

	$query = "DROP TABLE `glpi_plugin_data_injection_models`;";
	$DB->query($query) or die($DB->error());

	$query = "DROP TABLE `glpi_plugin_data_injection_models_csv`;";
	$DB->query($query) or die($DB->error());

	$query = "DROP TABLE `glpi_plugin_data_injection_mappings`;";
	$DB->query($query) or die($DB->error());

	$query = "DROP TABLE `glpi_plugin_data_injection_infos`;";
	$DB->query($query) or die($DB->error());

	$query = "DROP TABLE `glpi_plugin_data_injection_filetype`;";
	$DB->query($query) or die($DB->error());

	$query = "DROP TABLE `glpi_plugin_data_injection_profiles`;";
	$DB->query($query) or die($DB->error());

	if (is_dir(PLUGIN_DATA_INJECTION_UPLOAD_DIR)) {
		deleteDir(PLUGIN_DATA_INJECTION_UPLOAD_DIR);
	}
}

function plugin_data_injection_update131_14() {
	global $DB;
	$sql = "ALTER TABLE `glpi_plugin_data_injection_models` ADD `float_format` INT( 1 ) NOT NULL DEFAULT '0';";
	$DB->query($sql);

	//Template recursivity : need standardize names in order to use privatePublicSwitch
	$sql = " ALTER TABLE `glpi_plugin_data_injection_models` CHANGE `user_id` `FK_users` INT( 11 ) NOT NULL";
	$DB->query($sql);
	
	$sql = " ALTER TABLE `glpi_plugin_data_injection_models` CHANGE `public` `private` INT( 1 ) NOT NULL  DEFAULT '0'";
	$DB->query($sql);
	
	
	
	$sql="UPDATE `glpi_plugin_data_injection_models` SET FK_entities=-1 AND private=1 WHERE private=0";
	$DB->query($sql);
	
	$sql="UPDATE `glpi_plugin_data_injection_models` SET private=0 WHERE private=1 AND FK_entities>0";
	$DB->query($sql);
	
	$sql = "ALTER TABLE `glpi_plugin_data_injection_models` ADD `recursive` INT( 1 ) NOT NULL DEFAULT '0';";
	$DB->query($sql);

	$sql="UPDATE `glpi_plugin_data_injection_profiles` SET create_model=use_model WHERE create_model IS NULL";
	$DB->query($sql);

	$sql="ALTER TABLE `glpi_plugin_data_injection_profiles` DROP `use_model`";
	$DB->query($sql);
	
	$sql=" ALTER TABLE `glpi_plugin_data_injection_profiles` CHANGE `create_model` `model` CHAR( 1 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL";
	$DB->query($sql);
}

function plugin_data_injection_update14_15()
{
	global $DB;
	$query = "ALTER TABLE `glpi_plugin_data_injection_models` ADD `port_unicity` INT( 1 ) NOT NULL DEFAULT '0';";
	$DB->query($query);
}
function plugin_data_injection_initSession() {
	global $DB;

	if (!plugin_data_injection_needUpdateOrInstall() && is_dir(PLUGIN_DATA_INJECTION_UPLOAD_DIR) && is_writable(PLUGIN_DATA_INJECTION_UPLOAD_DIR)) {
		$profile = new DataInjectionProfile();

		$query = "SELECT DISTINCT glpi_profiles.* FROM glpi_users_profiles INNER JOIN glpi_profiles ON (glpi_users_profiles.FK_profiles = glpi_profiles.ID) WHERE glpi_users_profiles.FK_users='" . $_SESSION["glpiID"] . "'";
		$result = $DB->query($query);
		$_SESSION['glpi_plugin_data_injection_profile'] = array ();
		if ($DB->numrows($result)) {
			while ($data = $DB->fetch_assoc($result)) {
				$profile->fields = array ();
				if (isset ($_SESSION["glpiactiveprofile"]["ID"])) {
					$profile->getFromDB($_SESSION["glpiactiveprofile"]["ID"]);
					$_SESSION['glpi_plugin_data_injection_profile'] = $profile->fields;
				} else {
					$profile->getFromDB($data['ID']);
					$_SESSION['glpi_plugin_data_injection_profile'] = $profile->fields;
				}
				$_SESSION["glpi_plugin_data_injection_installed"] = 1;
			}
		}
	}
}

function plugin_data_injection_changeprofile() {
	if (isset ($_SESSION["glpi_plugin_data_injection_installed"]) && $_SESSION["glpi_plugin_data_injection_installed"] == 1) {
		$prof = new DataInjectionProfile();
		if ($prof->getFromDB($_SESSION['glpiactiveprofile']['ID']))
			$_SESSION["glpi_plugin_data_injection_profile"] = $prof->fields;
		else
			unset ($_SESSION["glpi_plugin_data_injection_profile"]);
	}
}

function plugin_data_injection_createfirstaccess($ID) {
	global $DB;

	$DataInjectionProfile = new DataInjectionProfile();
	if (!$DataInjectionProfile->GetfromDB($ID)) {

		$Profile = new Profile();
		$Profile->GetfromDB($ID);
		$name = $Profile->fields["name"];

		$query = "INSERT INTO `glpi_plugin_data_injection_profiles` ( `ID`, `name` , `is_default`, `model`) VALUES ('$ID', '$name','0','w');";
		$DB->query($query);
	}
}

function plugin_data_injection_createaccess($ID) {
	global $DB;

	$Profile = new Profile();
	$Profile->GetfromDB($ID);
	$name = $Profile->fields["name"];

	$query = "INSERT INTO `glpi_plugin_data_injection_profiles` ( `ID`, `name` , `is_default`, `model`) VALUES ('$ID', '$name','0',NULL);";

	$DB->query($query);
}

function plugin_data_injection_haveRight($module, $right) {
	$matches = array (
		"" => array (
			"",
			"r",
			"w"
		), // ne doit pas arriver normalement
	"r" => array (
			"r",
			"w"
		),
		"w" => array (
			"w"
		),
		"1" => array (
			"1"
		),
		"0" => array (
			"0",
			"1"
		), // ne doit pas arriver non plus

	
	);
	if (isset ($_SESSION["glpi_plugin_data_injection_profile"][$module]) && in_array($_SESSION["glpi_plugin_data_injection_profile"][$module], $matches[$right]))
		return true;
	else
		return false;
}

function plugin_data_injection_haveTypeRight($module,$right)
{
	return plugin_data_injection_haveRight("model", $right);	
}

function plugin_data_injection_checkRight($module, $right) {
	global $CFG_GLPI;

	if (!plugin_data_injection_haveRight($module, $right)) {
		// Gestion timeout session
		if (!isset ($_SESSION["glpiID"])) {
			glpi_header($CFG_GLPI["root_doc"] . "/index.php");
			exit ();
		}

		displayRightError();
	}
}

function plugin_data_injection_loadHook($hook_name, $params = array ()) {
	global $PLUGIN_HOOKS;

	if (!empty ($params)) {
		$type = $params["type"];
		//If a plugin type is defined
		$function = 'plugin_' . $PLUGIN_HOOKS['plugin_types'][$type] . '_data_injection_' . $hook_name;
		if (function_exists($function)) {
			$function ($type, $params);
		}
	} else
		if (isset ($PLUGIN_HOOKS['plugin_types'])) {
			//Browse all plugins
			foreach ($PLUGIN_HOOKS['plugin_types'] as $type => $name) {
				$function = 'plugin_' . $name . '_data_injection_' . $hook_name;
				if (function_exists($function)) {
					$function ($type, $params);
				}
			}
		}
}

function plugin_data_injection_needUpdateOrInstall()
{
	if (!TableExists("glpi_plugin_data_injection_models"))
		return 1;
	if (!FieldExists("glpi_plugin_data_injection_models","recursive"))
		return 2;	
	if (!FieldExists("glpi_plugin_data_injection_models","port_unicity"))
		return 2;
	else
		return 0;	
}
?>
